The Message
======================================

The primary goal of the Anypoint MQ REST API protocol is to produce and to consume messages. Therefore the Anypoint MQ message plays a central role of the Anypoint MQ REST protocol.

Anypoint MQ messages are not very different from other messaging protocols messages. An Anypoint MQ REST message has three parts: headers, properties, and a payload.

    ┌────────────────┐
    │    Headers     │
    ├────────────────┤
    │   Properties   │
    ├────────────────┤
    │                │
    │                │
    │    Payload     │
    │                │
    │                │
    └────────────────┘

An Anypoint MQ message has three elements: a header, properties, and a body. The mandatory parts are the properties and the body.

* Headers, courier defined metadata
* Properties, user defined metadata
* Body, payload of the message


Headers
--------------------------------------

Anypoint MQ message properties can be used to add custom information that does not belong, although it is probably related, to the payload.



Properties
--------------------------------------

Anypoint MQ-specific properties like `lockId`, `messageId`, or `deliveryCount`.


Payload
--------------------------------------

Anypoint MQ messages can only carry one kind of payload, a stream of uninterpreted bytes. This enables with proper encoding to send and to receive data in many different forms.
